import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')


@points('2.1')
class MainTest(unittest.TestCase):

    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_all_to_different_lines(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        lines = printed.split('\n')
        self.assertTrue(len(lines)>1,msg='Et tulostanut kaikkia tuloksia omalle rivilleen.')

    def test_02_prints_pi(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[0].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.pi,1e-8), msg='Et tulostanut piitä')

    def test_03_prints_correct_sine(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[1].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.sin(np.pi),1e-8), msg='Sin arvo ei ollut oikein.')

    def test_04_prints_correct_cosine(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[2].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.cos(np.pi),1e-8), msg='Cos arvo ei ollut oikein.')

    def test_05_prints_correct_tan(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[3].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.tan(np.pi),1e-8), msg='Tan arvo ei ollut oikein.')

    def test_06_prints_correct_x(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[4].strip()
        import numpy as np
        self.assertEqual(line, str(1),msg='Muuttujan x arvo oli väärä')

    def test_07_prints_correct_arcsine(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[5].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.arcsin(1),1e-8), msg='Arcsin arvo ei ollut oikein.')

    def test_08_prints_correct_arccos(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[6].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.arccos(1),1e-8), msg='Arccos arvo ei ollut oikein.')

    def test_09_prints_correct_arctan(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[7].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.arctan(1),1e-8), msg='Arctan arvo ei ollut oikein.')

